function [time_next_event, num_call_dropped,num_call_dropped_q, num_call_dropped_delay,sim_time, LinkStatusMat,DeptMat,oxc_sw_stat, ...
          oxc_sw_pwr,add_ports,drop_ports,LOG_MAT,tau_total]=arrive(time_next_event,sim_time, mean_interarrival,mean_service,...
          num_call_dropped,num_call_dropped_q, num_call_dropped_delay, Topo_No,LinkStatusMat,DeptMat,oxc_sw_stat,oxc_sw_pwr,add_ports, ...
          drop_ports,FiberPort,LOG_MAT,REQ_ID,MAX_NDS,tau_total)

mm=1e-3; % Used for converting the metric to milliseconds                                                                      
[DisMat, number_of_links,nds,num_of_wavelengths,q_th,max_degree,RT_METHOD,num_of_des,wave_assignment,tau_th]=constants(Topo_No);                                                                      
time_next_event(1)=sim_time+exprnd(mean_interarrival);
%tic % Records the time for each anycast request arrival
%%%%%%%%%%%%%%%%%%%%% Create an Anycast Request %%%%%%%%%%%%%%%%%%
% Start Date : June 26 2010
% End Date : Inf
tau_LP=0; % Initilization for the ligthpath configuration time to zero this time is initialized for every request
LP_start=toc; % Records the start time for the connection provision
[SrcNd, DesNds]=RandSD(nds, num_of_des);
% The set of DesNds should be sorted based on the RT_METHOD
SortDesNds=sorting(SrcNd,DesNds,Topo_No,DisMat,num_of_des,RT_METHOD);

%%%%%%%%% Start from here ! %%%%%%%%%%%%%%%%
% Array size of the Sorted Destination set is the same as that of the num_of_des

while (~isempty(SortDesNds))
        Route=dijkstra(SrcNd,SortDesNds(1),Topo_No,RT_METHOD); % We always select the first destination in the SortDesNds
        mdn=zeros(1,length(Route)-1);
        i=1;
        while(i<length(Route))
             mdn(i)=DisMat(Route(i),Route(i+1));
             i=i+1;
        end
        [max_avail_wave,avail_wave,wave_no]=wave_assign(LinkStatusMat, Route,num_of_wavelengths,wave_assignment);
        %SortDesNds
        if (max_avail_wave==0) % That is no free wavelength destination cannot be reached due to contention and hence the
                               % we should try another destination
            SortDesNds(1)=[]; % Removing the destination that is not reachable
            if isempty(SortDesNds)==1
                num_call_dropped=num_call_dropped+1; % Call dropped due to contention only if even cannot reach the last destination in the set of destinations
                % Since the request is blocked due to unavailablity of  wavelength
                LP_end=toc; % Since the request is blocked, request time is recorded
                tau_LP=tau_LP+(LP_end-LP_start)/mm; % toc value is in seconds. But since we need it in milliseconds, we multiply with mm
                            % Time taken for the request to be provisioned. That is to check the WCC in this case
                                           % Even though the request it blocked, it records the time for the blocked reques
            end
            
        else % Once the wavelength is assgined, we need to calculate the BER and check the threshold. If the threshold is meet than the route is configured
             % and the lightpath is established  % Start: 22 Nov 09  End: Inf ;)
             while(max_avail_wave~=0)
                     % Check the q-factor for all the wavelengths that are available
                     % wave_no
                    
                    [oxc_sw_stat,add_ports,drop_ports,oxc_sw_pwr,call_blocked_q]=configOXC(oxc_sw_stat,Route,mdn,wave_no,FiberPort,add_ports,drop_ports,...
                                                                                  oxc_sw_pwr,Topo_No);
                     
                    if  call_blocked_q==true
                        for i=1:length(avail_wave)
                            if avail_wave(i)==wave_no
                                break % break the for loop
                            end
                        end
                        avail_wave(i)=[]; % The value of i at which the loop breaks is the wave_no that needs to be removed
                        % Here we need to deconfigOXC since the LP at wavelength avail_wave(i) is not satisfying the q-factor and try for
                        % another wavelength and do it until we search the all the wavelengths 
                        %%%%%%%%%% DE CONFIG OXC To BE ADDED %%%%%%%%%%%%%%%%%%
                        [oxc_sw_stat,oxc_sw_pwr,add_ports,drop_ports]=deconfigOXC(oxc_sw_stat,oxc_sw_pwr,Route,wave_no,FiberPort,max_degree,add_ports,drop_ports);
                        %%%%%%%%%%%%%%%%%%%%%%%%
                        max_avail_wave=length(avail_wave);
                        if max_avail_wave~=0
                            switch wave_assignment
                                   case 1
                                        rd_array=randperm(length(avail_wave));
                                        rd_idx=rd_array(1); % Selecting a random index for the wavelength
                                        wave_no=avail_wave(rd_idx); % This is wavelength number that is selected randomly other words, wavelength index
                                   case 2
                                        wave_no=avail_wave(1); % Selecting the first wavelengths based on the wavelength number
                            end
                            
                        end
                    else
                        break % break the while loop for max_avail_wave
                     end
                  
             end
             %%% Check the delay thershold for the LP provisioning. % We do not provision the LP if 
             %%% the latency  exceeds Since the latency is a additivie constraint, if a threshold condition 
             %%% of a destination on  certain wavelength is violated, then it is apparant that all the other wavlengths 
             %%% for the  same destination and other destinations in the  anycast request will violate the latecy constraint.
             %%% Hence once the thershold exceeds, we consider the
             %%% entire anycast request to be dropped.
             LP_end=toc;
             tau_LP=tau_LP+(LP_end-LP_start)/mm;
              %tau_LP
             if (tau_LP > tau_th)&& (max_avail_wave~=0)&&(REQ_ID > 1) % The condition REQ_ID requires, since MATLAB takes some arbitary large time to set the variables so we are
                                                % counting after the first request.
                [oxc_sw_stat,oxc_sw_pwr,add_ports,drop_ports]=deconfigOXC(oxc_sw_stat,oxc_sw_pwr,Route,wave_no,FiberPort,max_degree,add_ports,drop_ports);
                num_call_dropped=num_call_dropped+1;
                num_call_dropped_delay=num_call_dropped_delay+1;
                break; % for the first while loop for the condition on SortDesNds, since the request has been satisfied
             else
                 if max_avail_wave==0
                    % num_call_dropped=num_call_dropped+1; % Here the q-factor does not satisfy the threshold required
                    % num_call_dropped_q=num_call_dropped_q+1; % Number of calls that does satisfy the q-factor
                    % Here since it is anycasting, we do not drop the request here, but rather try on an another destination
                   SortDesNds(1)=[]; % That means the destination cannot to be reached since there is no wavelength that can satisfy the q-factor
                   if isempty(SortDesNds)==1
                      num_call_dropped=num_call_dropped+1; % Call dropped only if the last destination in the set of destinations cannot be configured
                      num_call_dropped_q=num_call_dropped_q+1;
                   end

                 else
                    DeptMat(SrcNd,SortDesNds(1),wave_no,1)=sim_time+exprnd(mean_service);
                    DeptMat(SrcNd,SortDesNds(1),wave_no,2)=REQ_ID; % Assiging the Request ID to the LP that has been successfully configured
                    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                    %% Upon successful request, appened the details to the LOG_MAT
                        temp=zeros(1,MAX_NDS+4);
                        temp(1,1)=REQ_ID;
                        temp(1,MAX_NDS+2)=time_next_event(1); % Noting the arrival time
                        temp(1,MAX_NDS+3)=DeptMat(SrcNd,SortDesNds(1),wave_no,1); % Noting the departure time
                        temp(1,MAX_NDS+4)=wave_no; % Noting the wavelength Number
                        for k=1:length(Route)
                            temp(1,k+1)=Route(k); % Assigning the Route Information to the temp
                        end
                        if REQ_ID==1
                            LOG_MAT(1,:)=[];% Removing the row with zeros in the matrix, which is done only for the first time
                        end
                        LOG_MAT=[LOG_MAT;temp]; % Appending the details of the successful request to LOG_MAT
                        LinkStatusMat(Route(1),Route(2),wave_no)=1;
                        for h=2:length(Route)-1
                            LinkStatusMat(Route(h),Route(h+1),wave_no)=1;
                        end
                        MinDeptime=min(min(min(DeptMat(:,:,:,1)))); % It checks the min value amoung all the lightpaths
                        time_next_event(2)=MinDeptime;
                        if REQ_ID > 1
                           tau_total=tau_total+tau_LP;
                        end
                        % tau_tp=sum(mdn)/300; %this is the transmission delay (in ms) incurred in the optical data
                        % Here first do not consider the propagation delay,
                        % since that could be a dominating factor and the time
                        % taken for connection provisioning may not be taken
                        % into account
                        %tau_t=tau_LP +tau_tp; % this is the total delay for the lightpath in milli seconds
                        %%% Here we need to add the propagation delay for the LP provisionined between the source and the destination SrcNd,SortDesNds(1)

                        %% Here we consider no processing delay, i.e. in other words the anycast request are not queued.
                        break % for the first while loop for the condition on SortDesNds, since the request has been satisfied
                 end
             end
        end
 
end
    
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
