function call_blocked_q=imp_cons(mdn,wave_no,Topo_No)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%CONSTANTS
mm=1e-3;
c=3e8; % Velocity of light in mts/sec
bit_rate=10e9; % Bit rate per channel
Be=bit_rate; % electronic bandwidth: Note we can take the electronic bandwidth as 0.7 x bit_rate. However here we choose it same as the bit rate
Bo=70e9; % Optical Bandwidth
tx_pw=0; % Transmitter power at the Source node in dBm
F=2; % No. of fibers, which is 2 for bi-directional fibers
%**************************************************************************
%(All the switch losses are in dB )
[DisMat, number_of_links,nds,num_of_wavelengths,q_th,max_degree]=constants(Topo_No);
N=ceil(log2(2*max_degree));
L_mx=4; % Multiplexer Loss
L_dm=4; % Demultiplexer Loss
L_s=1; % Switch Element Inseration Loss
L_w=1; % Waveguide to fiber coupling loss
L_sw=2*log2(N)*L_s+4*L_w; % Swtich loss for the N*N switch; 
L_tap=1; % Tap loss
l=70; % This is the distance between the in-line amplifiers 
L=0.2; % fiber loss in dB/km % alpha=0.2 changed from 0.3 earlier
alpha=L/(10*log10(exp(1))); % This value of alpha is in (km)^(-1)
Gin_max=22; % Input EDFA gain 
Gout_max=16; % output EDFA gain
G_dB=10*log10(exp(alpha*l)); % This is the gain provided by the in-line amplification to compensate the fiber attenuation loss
nsp=1.5; % Amplified Spontaneous Emission Factor
h=6.63e-34; % Plank's Constant in J-s or J/Hz

%%%%%%%%%%%%%%%%%%%%%% Creating a wavlength array %%%%%%%%%%%%%%%%%%%%%%%
lambda_min=1542.6e-9; % Starting Wavelength
wave_spcg=0.8e-9; % Wavelength spacing
lambda_array=zeros(1,num_of_wavelengths);
for i=0:num_of_wavelengths-1
    lambda_array(i+1)=lambda_min+i*wave_spcg;
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
lambda=lambda_array(wave_no);
f_lam=c/lambda; % Carrier frequency in Hz
P_n = 2*nsp*h*f_lam*Bo/mm; % This is a constant used in the calculation of ASE power in mW
%**************************************************************************
nh=length(mdn); % Is the number of hops the signal traverses before reaching the destination.
A=ceil(mdn./l)-1; % This the number of amplifiers placed between the link for each fiber. 
UnComp_l=mdn-A.*l; % This is the uncompensated length of the fiber, for this there is a loss due to attenuation of the fiber.
p_out=zeros(1,nh+1); % Pout Matrix in mW
p_out(1,1)=tx_pw; % Intializing the input power in dBm.
p_out_m(1,1)=10^(p_out(1,1)/10); % In mW
p_ase_m(1,1)=P_n*(10^(Gin_max/10)-1)*10^(-L_mx/10)*10^(-L_dm/10)*10^(-L_sw/10)*10^(Gout_max/10)*10^(-L_tap/10)+P_n*(10^(Gout_max/10)-1)*10^(-L_tap/10);
p_ase_node=P_n*(10^(Gin_max/10)-1)*10^(-L_mx/10)*10^(-L_dm/10)*10^(-L_sw/10)*10^(Gout_max/10)*10^(-L_tap/10)+P_n*(10^(Gout_max/10)-1)*10^(-L_tap/10);
for i=2:nh+1
    p_out(1,i)=(p_out(1,i-1)+Gin_max+Gout_max)-(L_sw + L_mx+2*L_tap+L*UnComp_l(1,i-1)+L_dm); % AGC Model
    p_out_m(1,i)=10^(p_out(1,i)/10);
    p_ase_m(1,i)=p_ase_m(1,i-1)*exp(-alpha*UnComp_l(1,i-1))*10^(-L_tap/10)*10^(Gin_max/10)*10^(-L_dm/10)*10^(-L_sw/10)*10^(-L_mx/10)...
                 *10^(Gout_max/10)*10^(-L_tap/10)+P_n*(10^(G_dB/10)-1)*A(1,i-1)+p_ase_node;
end  
osnr=p_out_m./p_ase_m; % Optical Signal to Noise ratio.
q=(2*sqrt(Bo/Be).*osnr)./(1+sqrt(1+4.*osnr));
if q(nh+1)<q_th % q-factor at the final node
   call_blocked_q=true;
else
   call_blocked_q=false;
end