function [N,np_sd,Be,Bo,tx_pw,L_mx,L_dm,L_s,L_w,L_sw,L_tap,l,L,Xsw,Gin_max,Gout_max,G_dB,lambda_array,nsp,h,alpha,bit_rate,wave_spcg]=parameters(max_degree,num_of_wavelengths)
N=2^(ceil(log2(2*max_degree))); % Switch size N x N
np_sd=N-max_degree; % This is the number of input/output ports that can be used for add/drop by any OXC in the entire network
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%CONSTANTS
bit_rate=10e9; % Bit rate per channel
Be=0.7*bit_rate; % electronic bandwidth: Note we can take the electronic bandwidth as 0.7 x bit_rate. However here we choose it same as the bit rate
Bo=70e9; % Optical Bandwidth
tx_pw=0; % Transmitter power at the Source node in dBm
%**************************************************************************
%(All the switch losses are in dB )
L_mx=4; % Multiplexer Loss
L_dm=4; % Demultiplexer Loss
L_s=1; % Switch Element Inseration Loss
L_w=1; % Waveguide to fiber coupling loss
L_sw=2*log2(N)*L_s+4*L_w; % Swtich loss for the N*N switch; 
L_tap=1; % Tap loss
l=70; % This is the distance between the in-line amplifiers 
L=0.2; % fiber loss in dB/km
Xsw_dB=25; % Switch Cross talk Ratio in dB
Xsw=10^(-Xsw_dB/10); % Switch Cross talk Ratio in a.u
alpha=L/(10*log10(exp(1))); % This value of alpha is in (km)^(-1)
Gin_max=22; % Input EDFA gain 
Gout_max=16; % output EDFA gain
G_dB=10*log10(exp(alpha*l)); % This is the gain provided by the in-line amplification to compensate the fiber attenuation loss
nsp=1.5; % Amplified Spontaneous Emission Factor
h=6.63e-34; % Plank's Constant in J-s or J/Hz
%%%%%%%%%%%%%%%%%%%%%% Creating a wavlength array %%%%%%%%%%%%%%%%%%%%%%%
lambda_min=1542.6e-9; % Starting Wavelength
wave_spcg=0.8e-9; % Wavelength spacing
lambda_array=zeros(1,num_of_wavelengths);
for i=0:num_of_wavelengths-1
    lambda_array(i+1)=lambda_min+i*wave_spcg;
end
